/******************************************************************************
 *	File	:	EcmUsrDriver.h
 *	Version :	1.1
 *	Date	:	2021/01/26
 *	Author	:	XFORCE
 *
 *	ECM-XF basic driver example - Header file
 *
 *	Demonstrate how to implement API type user driver
 *
 * @copyright (C) 2020 NEXTW TECHNOLOGY CO., LTD.. All rights reserved.
 *
 ******************************************************************************/#include "EcmUsrDriver.h"
#include "EcmDacDriver.h"

extern SPI_CMD_PACKAGE_T *pCmd;
extern SPI_RET_PACKAGE_T *pRet;
extern uint8_t u8CmdIdx;

int ECM_DacOpen( uint32_t mode)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_DAC_FUNC_OP;
	pCmd->Head.u8Param = 20;
	pCmd->Head.u16Size = 4;
	memcpy( pCmd->Data, &mode, sizeof(uint32_t));
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_DacClose(void)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_DAC_FUNC_OP;
	pCmd->Head.u8Param = 21;
	pCmd->Head.u16Size = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_DacSetDelayTime( uint32_t delay)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_DAC_FUNC_OP;
	pCmd->Head.u8Param = 22;
	pCmd->Head.u16Size = 4;
	memcpy( pCmd->Data, &delay, sizeof(uint32_t));
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_DacSetData( uint32_t data)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_DAC_FUNC_OP;
	pCmd->Head.u8Param = 11;
	pCmd->Head.u16Size = 4;
	memcpy( pCmd->Data, &data, sizeof(uint32_t));
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}

int ECM_DacStartConv(void)
{
	int i=0;
	uint8_t IdxCheck;
	pCmd->Head.u8Cmd = ECM_DAC_FUNC_OP;
	pCmd->Head.u8Param = 0;
	pCmd->Head.u16Size = 0;
	pCmd->Head.u8Idx = u8CmdIdx++;
	for(i=0;i<100;i++){
		if(SpiDataExchange(&IdxCheck, 0)){
			if(pCmd->Head.u8Idx == IdxCheck){
				return 1;
			}
		}
	}
	return 0;
}
